/**
 * @brief GPIO pin interface definitions.
 */
#ifndef STA_GPIO_PIN_HPP
#define STA_GPIO_PIN_HPP


namespace sta
{
	/**
	 * @brief GPIO pin state
	 */
	enum class GpioPinState
	{
		LOW,
		HIGH
	};

	/**
	 * @brief Interface for GPIO pins.
	 */
	class GpioPin
	{
	public:
		/**
		 * @brief Set pin output state.
		 *
		 * @param state     Output state
		 */
		virtual void setState(GpioPinState state) = 0;
	};
} // namespace sta


#endif // STA_GPIO_PIN_HPP
