#include <sta/atomic/signal.hpp>
#ifdef STA_ATOMIC_ENABLE


namespace sta
{
	AtomicSignal::AtomicSignal()
		: signal_{false}
	{}

	void AtomicSignal::notify()
	{
		signal_.store(true);
	}

	bool AtomicSignal::peek()
	{
		return signal_.load();
	}

	bool AtomicSignal::test()
	{
		return signal_.exchange(false);
	}

	void AtomicSignal::wait()
	{
		while (!signal_.exchange(false));
	}
} // namespace sta


#endif // STA_ATOMIC_ENABLE
