#include <sta/hal/gpio_pin.hpp>

#ifdef STA_HAL_GPIO_ENABLE

#include <sta/assert.hpp>


namespace sta
{
	HalGpioPin::HalGpioPin(GPIO_TypeDef * port, uint16_t pin)
		: port_{port}, pin_{pin}
	{
		STA_ASSERT(port != nullptr);
	}

	void HalGpioPin::setState(GpioPinState state)
	{
		HAL_GPIO_WritePin(port_, pin_, (state == GpioPinState::LOW) ? GPIO_PIN_RESET : GPIO_PIN_SET);
	}
} // namespace sta


#endif // STA_HAL_GPIO_ENABLE
